       		
  
     !----------------------------------------------------------------------------------------------
     !PROGRAM createIceRefLibraryHDF
     !INPUTS :
     !			NONE yet
     !OUTPUTS:
     !			NONE yet
     !ROUTINES CALLED:
     !			getDateAndTime :  contains in the program itself
     !MODULES USED:
     !			HDF.f90, DFFUNC.f90
     !
     !----------------------------------------------------------------------------------------------
      
     PROGRAM createIceRefLibraryHDF_EMAS_DP_WithReUNC
     IMPLICIT NONE
     INCLUDE "hdf.f90"
     INCLUDE "dffunc.f90"
     
     
     INTEGER,PARAMETER:: numOfTau					=	34, &
     					 numOfSolarAngs				=	33, &
     					 numOfViewAngs				=	28, &
                         numOfAzmAngs				=	37, &
                         numOfWavelengths			=	 11, &
                         numOfWavelengthsRFTF		=	 11, &
                         numOfSolarAngsRFTF			=	33, &  
                         numOfViewAngsRFTF			=	33
     
     INTEGER::numOfIceRE,allocateStatus
 
     INTEGER*4:: sd_id, sds_id, rank, dim_id,hdf_id,dimArray(7),start(7),edges(7),stride(7)
     integer*4:: DIM0,DIM1,DIM2,DIM3,DIM4,DIM5
     integer:: dims(2) !, start(2), edges(2), stride(2)
     integer:: i, j, k, retstat
     CHARACTER(200) :: outHDFFileName, dataDescription,phaseDescription,softwareDescription, &
     					programName,dimensionName,SDSName,comment,longName, habitDescription,radiometer,RSRFilesCreated,version,historyrsr,historyice,historywater
     CHARACTER(11)  :: whatdate
     CHARACTER(8)   :: whattime
               CHARACTER(13)::dateTimeString

     REAL,DIMENSION(numOfWavelengths)::waveLengths & 
                        = (/   0.66,  0.87,  1.88, 1.612, 1.67, 2.14, 2.184,2.232,2.282,3.74, 11.00/)
     REAL,DIMENSION(numOfWavelengths)::solarFlux = (/ 79.28, 39.11,6.05, 13.55, 11.55, 4.00, 3.71,3.56,3.34,2.02, 0.05/)
     REAL,DIMENSION(numOfWavelengthsRFTF)::waveLengthsRFTF & 
    											 = (/  0.66,  0.87,  1.88, 1.612, 1.67, 2.14, 2.184,2.232,2.282,3.74, 11.00/)
                        
!     REAL*4, DIMENSION&
!     (1:numOfWavelengths,&
!     1:numOfSolarAngs,&
!     1:numOfTau,&
!     1:numOfRe,&
!     1:numOfViewAngs,&
!     1:numOfFourierCoeff)	:: fcData     !Fourier Coefficient Array
     
     REAL*4,ALLOCATABLE::multiScatRefl(:,:,:,:,:,:), stdDevEffecVar(:,:,:,:,:,:),sphericalAlbedo(:,:,:),planeAlbedo(:,:,:,:), transmittivity(:,:,:,:), &
     					 & effecRadii(:),extCoeffs(:,:),ssAlbedo(:,:),asymParameter(:,:),truncFac(:,:),pmom0Array(:,:),iReIce(:),temparray2(:,:,:,:,:)
!     (1:numOfViewAngs,&
!      1:numOfSolarAngs,&
!      1:numOfAzmAngs,&
!      1:numOfTau,&
!      1:numOfWavelengths,&
!      1:numOfRe)	:: multiScatRefl    !Multi Scattering part of the reflection

     
!	 REAL*4, DIMENSION&
!     (1:numOfTau,&
!     1:numOfWavelengthsRFTF,&
!     1:numOfRe)			   	:: sphericalAlbedo
     
!     REAL*4,DIMENSION&
!     (1:numOfSolarAngsRFTF,&
!     1:numOfTau,&
!     1:numOfWavelengthsRFTF,&
!     1:numOfRe)				::planeAlbedo, transmittivity


     REAL*4, DIMENSION&
     (1:numOfViewAngs,&
      1:numOfSolarAngs,&
      1:numOfAzmAngs,&
      1:numOfTau,&
      1:2,&
      1:12)	:: multiScatRefltemp    !Multi Scattering part of the reflection
	
     
     REAL*4 ::myTauValues(numOfTau),solarmu(NumOfSolarAngs),relazm(1:numOfAzmAngs), &
              viewmu(numOfViewAngs) !,extCoeffs(numOfWavelengths, numOfRe),effecRadii(numOfRe), &
!              ssAlbedo(numOfWavelengths, numOfRe),asymParameter(numOfWavelengths, numOfRe), &
!              truncFac(numOfWavelengths, numOfRe),pmom0Array(numOfWavelengths, numOfRe)
              
     REAL*4:: solarmuRFTF(numOfSolarAngsRFTF) !,asymParameterRFTF(numOfWavelengthsRFTF, numOfRe),extCoeffsRFTF(numOfWavelengthsRFTF, numOfRe), &
!              truncFacRFTF(numOfWavelengthsRFTF, numOfRe), &
!              ssAlbedoRFTF(numOfWavelengthsRFTF, numOfRe)
              
     REAL*4 :: deltamu0=0.025,deltamu=0.025,surfAlbedo
     REAL*8::scaleFactor
          character*6::instr

     
     
     myTauValues =(/0.05,  0.10,  0.25,  0.50, 0.75,  1.0,   1.25,  1.5,   1.75,  2.0,   2.39, &
	               2.87,  3.45,  4.14,  4.97,  5.96,  7.15,  8.58,  10.30, 12.36, 14.83, &
	               17.80, 21.36, 25.63, 30.76, 36.91, 44.30, 53.16, 63.80, 76.56, 91.88, &
	               110.26,132.31,158.78/)
!	 solarmu     = (/ (deltamu0 * i+0.15, i=0,34) /)
!	 viewmu      = (/(deltamu * i + 0.40,i=0,24) /)
	 
	 
	 solarmu(1:13)   = (/ (0.05d0 * i+0.15d0, i=0,12) /) !numOfSolarAngs = 33, numOfViewAngs = 28
	 viewmu(1:8)     = (/(0.05d0 * i + 0.40d0,i=0,7) /)
	 solarmu(14:numOfSolarAngs)   = (/ (0.0125d0 * i+0.7625d0, i=0,19) /) !numOfSolarAngs = 33, numOfViewAngs = 28
	 viewmu(9:numOfViewAngs)     = (/(0.0125d0 * i + 0.7625d0,i=0,19) /)
	 
	 solarmuRFTF = solarmu !(/ (0.05* i + 0.15, i=0,17) /)
	 relazm = (/(i *5.0, i=0,36)/)
	 surfAlbedo=0.0
	 


	 	 version = 'v6.EMAS.1.0.4' 
	     CALL getdateAndTime(whatdate, whattime,dateTimeString)
	 
	 
	    	write(*,*)'Chosse Ice Crystal Habit Type (abbreviated < 7 characters) ex: C51,SBR, HBR,GHM,COL,ACL'
   	read(*,*)instr
	
	   	if(TRIM(instr) == 'C51')THEN
   		numOfIceRE = 15
   		ALLOCATE(iReICe(1:numOfIceRE),STAT=allocateStatus)
 		   IF(allocatestatus /=0) THEN
					WRITE(*,*)'Memory allocate Error, PGM STOPS'
					STOP
			ENDIF

   		iReIce=(/5,10,15,20,25,30,35,40,45,50,55,60,70,80,90/) 
   	endif
   	
   	if(TRIM(instr) == 'GHM' .OR. TRIM(instr) == 'COL' .OR. TRIM(instr) == 'ACL')THEN
   		numOfIceRE = 12
   		ALLOCATE(iReICe(1:numOfIceRE),STAT=allocateStatus)
 		   IF(allocatestatus /=0) THEN
					WRITE(*,*)'Memory allocate Error, PGM STOPS'
					STOP
			ENDIF
   		
   		iReIce=(/5,10,15,20,25,30,35,40,45,50,55,60/) 
   	endif
   	
   	
   	if(TRIM(instr) == 'SBR')THEN
   		numOfIceRE = 11
   		ALLOCATE(iReICe(1:numOfIceRE),STAT=allocateStatus)
 		   IF(allocatestatus /=0) THEN
					WRITE(*,*)'Memory allocate Error, PGM STOPS'
					STOP
			ENDIF
   		
   		iReIce=(/5,10,15,20,25,30,35,40,45,50,55/) 
   	endif
 
    	if(TRIM(instr) == 'HBR')THEN
   		numOfIceRE = 9
   		ALLOCATE(iReICe(1:numOfIceRE),STAT=allocateStatus)
 		   IF(allocatestatus /=0) THEN
					WRITE(*,*)'Memory allocate Error, PGM STOPS'
					STOP
			ENDIF   		
   		iReIce=(/5,10,15,20,25,30,35,40,45/) 
   	endif


	 
	 
	 
	 	ALLOCATE(multiScatRefl (1:numOfViewAngs,1:numOfSolarAngs,1:numOfAzmAngs,1:numOfTau,1:numOfWavelengths,1:numOfIceRe), &
	 	         stdDevEffecVar(1:numOfViewAngs,1:numOfSolarAngs,1:numOfAzmAngs,1:numOfTau,1:numOfWavelengths,1:numOfIceRe), &	 	
                 sphericalAlbedo(1:numOfTau,1:numOfWavelengthsRFTF,1:numOfIceRe), &
                 planeAlbedo(1:numOfSolarAngsRFTF,1:numOfTau,1:numOfWavelengthsRFTF,1:numOfIceRe), &
                 transmittivity(1:numOfSolarAngsRFTF,1:numOfTau,1:numOfWavelengthsRFTF,1:numOfIceRe), &
					extCoeffs(numOfWavelengths, numOfIceRe),effecRadii(numOfIceRe), &
                 ssAlbedo(numOfWavelengths, numOfIceRe),asymParameter(numOfWavelengths, numOfIceRe), &
                 truncFac(numOfWavelengths, numOfIceRe),pmom0Array(numOfWavelengths, numOfIceRe), &
                 temparray2(1:numOfViewAngs,1:numOfSolarAngs,1:numOfAzmAngs,1:numOfTau,1:numOfIceRe) ) 	

	 extCoeffs   = 0.0
	 ssAlbedo    = 0.0 
	 asymParameter=0.0
	 multiScatRefl=64.0
	 sphericalAlbedo = 0.0
	 planeAlbedo = 0.0
	 transmittivity = 0.0
	 pmom0array = 0.0
	 
	 effecRadii = iReICe

	 
	 
	 OPEN(unit= 53,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/ICE_refl_MULTI_combined_LUT_11_CHS_DP_asurf_00.dat',status='old',action='read'&
 	   					&,form='unformatted')
	 READ(53)multiScatRefl(:,:,:,:,:,:)
 	 CLOSE(53)
	 OPEN(unit= 53,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/ICE_refl_MULTI_combined_LUT_b10_b11_DP_asurf_00.dat',status='old',action='read'&
 	   					&,form='unformatted')
	 READ(53)multiScatRefltemp
 	 CLOSE(53)
        multiScatRefl(:,:,:,:,4:5,:) = multiScatRefltemp(:,:,:,:,:,:)


 	 
 
!	 OPEN(unit= 53,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/ICE_refl_MULTI_combined_LUT_11_CHS_DP_asurf_00_b10_only.dat',status='old',action='read'&
! 	   					&,form='unformatted')
!	 READ(53)stdDevEffecVar(:,:,:,:,:,:)
! 	 CLOSE(53)
 	 
! multiScatRefl(:,:,:,:,4,:) = stdDevEffecVar(:,:,:,:,4,:)
 	 

	 OPEN(unit= 53,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/ICE_refl_FULL_combined_LUT_11_CHS_DP_asurf_00_ACL_stddev_v05_v10_v20.dat',status='old',action='read'&
 	   					&,form='unformatted')
	 READ(53)stdDevEffecVar(:,:,:,:,:,:)
 	 CLOSE(53)

	 OPEN(unit= 53,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/ICE_refl_FULL_combined_LUT_ch10_ch11_DP_asurf_00_ACL_stddev_v05_v10_v20.dat',status='old',action='read'&
 	   					&,form='unformatted')
	 READ(53)multiScatRefltemp
 	 CLOSE(53)

  	 stdDevEffecVar(:,:,:,:,4:5,:) = multiScatRefltemp(:,:,:,:,:,:)
	 
   
 	 
	 
   		OPEN(unit= 54,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/V10/RFTF/plane_albedo_RFTF.dat',status='old',& 
    		                    action='read',form='unformatted')
     		READ(54)planeAlbedo
       		CLOSE(54)   
       		!
    		OPEN(unit= 54,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/V10/RFTF/transmitted_flux_RFTF.dat',status='old',& 
    		                    action='read',form='unformatted')
     		READ(54)transmittivity
       		CLOSE(54) 
     		OPEN(unit= 54,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/V10/RFTF/spherical_albedo_RFTF.dat',status='old',& 
    		                    action='read',form='unformatted')
     		READ(54)sphericalAlbedo
       		CLOSE(54) 
      		
       		
          OPEN(unit= 54,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/V10/RFTF/asymparameter_RFTF.dat',status='old', &
       							action='read',form='unformatted')
     		READ(54)asymParameter
       		CLOSE(54)
    		

 	 		
           OPEN(unit= 54,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/V10/RFTF/ssalbedo_RFTF.dat',status='old', &
       							action='read',form='unformatted')
     		READ(54)ssAlbedo
       		CLOSE(54)
	 		
           OPEN(unit= 54,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/V10/RFTF/truncation_factor_f1_RFTF.dat',status='old', &
       							action='read',form='unformatted')
     		READ(54)truncFac
       		CLOSE(54)
 	 		
           OPEN(unit= 54,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/V10/RFTF/extinction_coefficient_RFTF.dat',status='old', &
       							action='read',form='unformatted')
     		READ(54)extCoeffs
       		CLOSE(54)
 	 		
  !      		OPEN(unit= 54,file='/Volumes/NDA1TBWD/LOOKUPTABLES/ICE/phase_fun_normalization_const_7_CHS_64.dat',status='old',& 
  !  		                    action='read',form='unformatted')
  
            OPEN(unit= 54,file='/Volumes/LaCieA/EMAS_LIBRARIES/LUT_DATA/DP/ICE/'//trim(instr)//'/V10/RFTF/phase_fun_normalization_const.dat',status='old', &
       							action='read',form='unformatted') 
     		READ(54)pmom0Array
       		CLOSE(54) 	
 	

!				truncFac(6,12:15) = (/0.68067990,0.70070204,0.72194405,0.71278147/)     !need to add NSTR=128 f values since
																		     !these RE's were run with NSTR = 128 for chan=6, to be consistent with cox monk libraries

 	
 	 		
 !    		OPEN(unit= 54,file='/Volumes/NDA1TBWD/LOOKUPTABLES/WATER/extinction_coefficent_64.dat',status='old',& 
!    		                    action='read',form='unformatted')
!     		READ(54)extCoeffs
!       		CLOSE(54)   
!      
!      		OPEN(unit= 54,file='/Volumes/NDA1TBWD/LOOKUPTABLES/WATER/extinction_coefficent_ref_64.dat',status='old',& 
!    		                    action='read',form='unformatted')
!     		READ(54)extCoeffs_ref
!       		CLOSE(54)  
!       		
!       		extCoeffs(1,:) = extCoeffs_ref(:)
!       		
!     		OPEN(unit= 54,file='/Volumes/NDA1TBWD/LOOKUPTABLES/WATER/ssalbedo_64.dat',status='old', & 
!     							action='read',form='unformatted')
!     		READ(54)ssAlbedo
!       		CLOSE(54)    
!       		
!       		ssAlbedo(1,1:8) = 1.0
!       		ssAlbedo(1,9:15) = 0.99999
!       		OPEN(unit= 54,file='/Volumes/NDA1TBWD/LOOKUPTABLES/WATER/asymparameter.dat',status='old', &
!       							action='read',form='unformatted')
!     		READ(54)asymParameter
!       		CLOSE(54)       
!       		OPEN(unit= 54,file='/Volumes/NDA1TBWD/LOOKUPTABLES/WATER/truncation_factor_f1_64.dat',status='old', &
!       							action='read',form='unformatted')
!     		READ(54)truncFac
!       		CLOSE(54)     
       		
!       		truncFac(1,:) = (/0.053100, 0.311938, 0.374016, 0.403878, 0.422197,0.438707,0.451487, 0.458681, &
!       		                 0.465362, 0.468712,0.474121, 0.484774, 0.488541,  0.492369, 0.496781 /) 
!       		 truncFac(1,:) = (/0.000929,0.127767,0.286209,0.346014,0.375029,0.393601,0.407084,0.417458,&
!       		                 0.425735, 0.432462,0.438024,0.442708,0.446731,0.450284,0.453349/)

!       	    pmom0Array(1,:) =(/1.0024496316909790, 1.0050827264785767, 1.0080716609954834,  1.0114520788192749, &
!       	                       1.0152711868286133,  1.0193679332733154, 1.0237452983856201,  1.0290882587432861, &
!       	                       1.0345239639282227,  1.0396416187286377,  1.0456006526947021,  1.0514757633209229,&
!       	                        1.0581188201904297,  1.0641508102416992,  1.0706315040588379 /)
!    		pmom0Array(1,:)	=(/ 0.4999997615814209, 0.4999996423721313,0.5000002980232239,0.5000029802322388,&
!     							0.5000084638595581,0.5000183582305908,0.5000343918800354,0.5000585317611694,&
!     							0.5000923871994019,0.5001386404037476,0.5001989603042603,0.5002667903900146,&
!     							0.5003315806388855,0.5004178881645203,0.5005216598510742/)


     !Program statements start here
     outHDFFileName      = '/Volumes/LaCieA/test2/lambertian_msr_ice_'//trim(version)//'.'//trim(dateTimeString)//'.hdf'
     print*,outHDFFileName 
     softwareDescription = "DISORT Version 2, which supports Nakajima-Tanaka Correction: Double precision" 
     programName         = 'createIceRefLibraryHDF.f90'
phaseDescription    = 'EMAS - ICE (ACOL) with corrected re integration and (solar+sensor)  weighted R and (sensor+emission) weighted emissivity'


     historyrsr = "Contains 18 water REs, veff=0.10, asurf=0.0 : 11CHs with RSR from Mar 2017, Post Oracle"
            historyice = "This version (sol+sensor) weighting included, and CT= 230K; EMISSION with (SENSOR+EM) weighting: Updated CH10&CH11 only "
            historywater = "Temperature is set at 270K;  EMISSION with (SENSOR+EM) weighting : Updated CH10&CH11 only"

	!
    !Create and open the HDF file and initiate the SD interface
	!
     hdf_id = sfstart(trim(outHDFFileName), DFACC_CREATE) 
     IF (hdf_id == Fail) THEN
     	WRITE(*,*)"Error in creating the file ", trim(outHDFFileName)
       	STOP
     ENDIF
 

    dataDescription="EMAS - Multi scattered part of the Lammbertian Relectance Look Up Table"
     habitDescription = 'Aggregate Columns - Gamma, var = 0.10'
      radiometer='EMAS'

    !print*,whatdate,'  ',whattime
    retstat = sfsnatt(hdf_id, "Version: ", DFNT_CHAR, len(trim(version)), trim(version))
	retstat = sfsnatt(hdf_id, "Date of File Created", DFNT_CHAR, len(trim(whatdate)), trim(whatdate))
    retstat = sfsnatt(hdf_id, "Time of File Created", DFNT_CHAR, len(trim(whattime)), trim(whattime))
        retstat = sfsnatt(hdf_id, "HistoryRSR", DFNT_CHAR, len(trim(historyrsr)), trim(historyrsr))
        retstat = sfsnatt(hdf_id, "History-Ice", DFNT_CHAR, len(trim(historyice)), trim(historyice))
         retstat = sfsnatt(hdf_id, "History-Water", DFNT_CHAR, len(trim(historywater)), trim(historywater))

    retstat = sfscatt(hdf_id, "Data Description", DFNT_CHAR, len(trim(dataDescription)), trim(dataDescription))
    retstat = sfscatt(hdf_id, "Thermodynamic Phase", DFNT_CHAR, len(trim(phaseDescription)), trim(phaseDescription))
    retstat = sfsnatt(hdf_id, "Habit Type", DFNT_CHAR, len(trim(habitDescription)), trim(habitDescription))

    retstat = sfscatt(hdf_id, "Fortran Program Name", DFNT_CHAR, len(trim(programName)), trim(programName))
    retstat = sfsnatt(hdf_id, "Software Used to Create Data", DFNT_CHAR, len(trim(softwareDescription)), trim(softwareDescription))
        retstat = sfsnatt(hdf_id, "Instrument", DFNT_CHAR, len(trim(radiometer)), trim(radiometer))

   ! retstat = sfsnatt(hdf_id, "Surface Albedo", DFNT_FLOAT, 1, surfAlbedo)      
   ! retstat = sfscatt(hdf_id, "Number of  Optical Thickness",DFNT_INT32,1,numOfTau)
   ! retstat = sfscatt(hdf_id, "Number of Wavelengths: Rflectances",DFNT_INT32,1,numOfWavelengths)
   ! retstat = sfscatt(hdf_id, "Number of Wavelengths: Fluxes",DFNT_INT32,1,numOfWavelengthsRFTF)
   ! retstat = sfscatt(hdf_id, "Number of SolarAngles",DFNT_INT32,1,numOfSolarAngs)
   ! retstat = sfscatt(hdf_id, "Number of Viewing Angles",DFNT_INT32,1,numOfViewAngs)
   ! retstat = sfscatt(hdf_id, "Number of Effective Droplet Radii",DFNT_INT32,1,numOfRe)
   ! retstat = sfscatt(hdf_id, "Number of Relative Azimuth Angles ",DFNT_INT32,1,numOfAzmAngs)    
    
        
        
        
                RSRFilesCreated = 'Mar_17/msr0317a.c##'
        
            retstat = sfsnatt(hdf_id, "RSR FILES DATE STAMP", DFNT_CHAR, len(trim(RSRFilesCreated)), trim(RSRFilesCreated))


   ! retstat = sfsnatt(hdf_id, "Surface Albedo", DFNT_FLOAT, 1, surfAlbedo)      
   ! retstat = sfscatt(hdf_id, "Number of  Optical Thickness",DFNT_INT32,1,numOfTau)
   ! retstat = sfscatt(hdf_id, "Number of Wavelengths: Rflectances",DFNT_INT32,1,numOfWavelengths)
   ! retstat = sfscatt(hdf_id, "Number of Wavelengths: Fluxes",DFNT_INT32,1,numOfWavelengthsRFTF)
   ! retstat = sfscatt(hdf_id, "Number of SolarAngles",DFNT_INT32,1,numOfSolarAngs)
   ! retstat = sfscatt(hdf_id, "Number of Viewing Angles",DFNT_INT32,1,numOfViewAngs)
   ! retstat = sfscatt(hdf_id, "Number of Effective Droplet Radii",DFNT_INT32,1,numOfRe)
   ! retstat = sfscatt(hdf_id, "Number of Relative Azimuth Angles ",DFNT_INT32,1,numOfAzmAngs)    
    
     
	!
	!Fourier Coefficients for calculating Reflectances

	
	
	!------Create the SDS, Multiple scattering part of the reflectance------------------------------
	rank  = 6
	start(:)=0
	stride(:)=1
	!dimArray(1:6) = (/ numOfFourierCoeff,numOfViewAngs,numOfRe,numOfTau,numOfSolarAngs,numOfWavelengths/)
	DIM0 = numOfViewAngs
	DIM1 = numOfSolarAngs
	DIM2 = numOfAzmAngs
	DIM3 = numOfTau
	DIM4 = numOfWavelengths
	DIM5 = numOfIceRe 
	dimArray(1:6) = (/DIM0,DIM1,DIM2,DIM3,DIM4,DIM5/)
	
	edges(1:6)=dimArray(1:6)
	

	SDSName = 'MultiScatBDReflectance'
	sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
	retstat = sfwdata(sds_id, start(1:6), stride(1:6), edges(1:6), multiScatRefl)
	
	dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//': NumOfViewAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    	dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//':NumOfSolarAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    	dim_id = sfdimid(sds_id,2)
    dimensionName = TRIM(SDSName)//': NumOfAzimuthAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
	dim_id = sfdimid(sds_id,3)
    dimensionName = TRIM(SDSName)//': NumOfOpticalThickness'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
        dim_id = sfdimid(sds_id,4)
    dimensionName = TRIM(SDSName)//': NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
		
	
	  dim_id = sfdimid(sds_id,5)
    dimensionName = TRIM(SDSName)//': NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
	

	
	



	scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName =  'Multi Scattering part of the Bidirectional Reflectance'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))
    
	retstat = sfendacc(sds_id)
	
	
    !------Create the SDS, STDDEV MS part due to effective variance  of RE--------------------------
	rank  = 6
	start(:)=0
	stride(:)=1
	!dimArray(1:6) = (/ numOfFourierCoeff,numOfViewAngs,numOfRe,numOfTau,numOfSolarAngs,numOfWavelengths/)
	DIM0 = numOfViewAngs
	DIM1 = numOfSolarAngs
	DIM2 = numOfAzmAngs
	DIM3 = numOfTau
	DIM4 = numOfWavelengths
	DIM5 = numOfIceRe 
	dimArray(1:6) = (/DIM0,DIM1,DIM2,DIM3,DIM4,DIM5/)
	
	edges(1:6)=dimArray(1:6)
	

	SDSName = 'StdDevMultiScatBDReflectance'
	sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
	retstat = sfwdata(sds_id, start(1:6), stride(1:6), edges(1:6),stdDevEffecVar)
	
	dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//': NumOfViewAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    	dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//':NumOfSolarAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    	dim_id = sfdimid(sds_id,2)
    dimensionName = TRIM(SDSName)//': NumOfAzimuthAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
	dim_id = sfdimid(sds_id,3)
    dimensionName = TRIM(SDSName)//': NumOfOpticalThickness'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
        dim_id = sfdimid(sds_id,4)
    dimensionName = TRIM(SDSName)//': NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
		
	
	  dim_id = sfdimid(sds_id,5)
    dimensionName = TRIM(SDSName)//': NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
	
    
	

	scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName =  'Std Deviation of the MS refletance due to effective RE varianve'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))
    
	retstat = sfendacc(sds_id)
	
	
	
	
	!------Create the SDS Wavelengths for Reflectance-----------------------------------
	rank =1
	start(1)=0
	edges(1)=numOfWavelengths
	stride(1)=1
	dimArray(1) = numOfWavelengths
	
 !   SDSName = 'WaveLengthsReflectance'
 	SDSName = 'Wavelengths'

    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), waveLengths)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
   
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'microns')
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName = 'Wavelengths for which the Multi Scat part of the Refl is computed'
    retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))
   
    retstat = sfendacc(sds_id)
	
!------Create the SDS Solar Fluxes at each lambda-----------------------------------
!	rank =1
!	start(1)=0
!	edges(1)=numOfWavelengths
!	stride(1)=1
!	dimArray(1) = numOfWavelengths
!	
!    SDSName = 'SolarFluxRefelectance'
!    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
!    
!    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), solarFlux)
!    dim_id = sfdimid(sds_id,0)
!    dimensionName = TRIM(SDSName)//':  NumOfWaveLengths'
!    retstat = sfsdmname(dim_id, trim(dimensionName))
!   
!    !Units
!    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'microns')
!    !scale_factor
!    scaleFactor = 1.d0
!    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
!       
!    retstat = sfendacc(sds_id)	
	

	!------Create the SDS Optical Thickness---------------------------------------------
	rank =1
	start(1)=0
	edges(1)=numOfTau
	stride(1)=1
	dimArray(1) = numOfTau
	
    SDSName = 'OpticalThickness'
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), myTauValues)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfOpticalThickness'
    retstat = sfsdmname(dim_id, trim(dimensionName))
   
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
    !scale_factor
    scaleFactor = 1.d0
    comment = 'Elements 1:10 linear in Tau space'
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    retstat = sfsnatt(sds_id, 'Comment-1', DFNT_CHAR, len(TRIM(comment)), trim(comment))
    comment = 'Elements 11:34 linear in log10(Tau) space'
 	retstat = sfsnatt(sds_id, 'Comment-2', DFNT_CHAR, len(TRIM(comment)), trim(comment))    
    
  	retstat = sfendacc(sds_id)
  	
  	
  	!------Create the SDS Effective Droplet radiii--------------------------------------
	rank =1
	start(1)=0
	edges(1)=numOfIceRe
	stride(1)=1
	dimArray(1) = numOfIceRe
	
    SDSName = 'ParticleRadius' !'EffectiveParticleRadii'
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), effecRadii)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'microns')
       
    !scale_factor
    scaleFactor = 1.d0
    
     
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName = 'Effective Particle Radius'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

  	retstat = sfendacc(sds_id)
  	
  	
  	
  	!------Create the SDS Cosine of Solar Zenith----------------------------------------
	rank =1
	start(1)=0
	edges(1)=numOfSolarAngs
	stride(1)=1
	dimArray(1) = numOfSolarAngs
	
   ! SDSName = 'ReflectanceMU0' !'ReflCosineOfSolarAng'
    SDSName = 'ReflectanceSolarZenith' !'ReflCosineOfSolarAng'
    
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), solarmu)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfSolarAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    
    !delta mu0
    !retstat = sfsnatt(sds_id, 'increment=deltamu0', DFNT_FLOAT, 1, deltamu0)
	longName ='Reflectance: Cosine of the Solar Angle'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

    
    comment = 'Elements 1:13, deltamu0 = 0.05'
    retstat = sfsnatt(sds_id, 'Comment-1', DFNT_CHAR, len(TRIM(comment)), trim(comment))
    comment = 'Elements 13:33, deltamu0 = 0.0125'
 	retstat = sfsnatt(sds_id, 'Comment-2', DFNT_CHAR, len(TRIM(comment)), trim(comment))    

    
  	retstat = sfendacc(sds_id)
  	
  	!------Create the SDS Cosine of Viewing Zenith--------------------------------------
	rank =1
	start(1)=0
	edges(1)=numOfViewAngs
	stride(1)=1
	dimArray(1) = numOfViewAngs
	
    !SDSName = 'ReflectanceMU'!'ReflCosineOfViewAng'
    SDSName = 'ReflectanceSensorZenith' !'ReflCosineOfSolarAng'

    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), viewmu)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfViewAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
   longName = 'Reflectance: Cosine of the View Angle'
  	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

    !delta mu
   ! retstat = sfsnatt(sds_id, 'increment=deltamu', DFNT_FLOAT, 1, deltamu)
    comment = 'Elements 1:13, deltamu = 0.05'
    retstat = sfsnatt(sds_id, 'Comment-1', DFNT_CHAR, len(TRIM(comment)), trim(comment))
    comment = 'Elements 13:33, deltamu = 0.0125'
 	retstat = sfsnatt(sds_id, 'Comment-2', DFNT_CHAR, len(TRIM(comment)), trim(comment))    

    
  	retstat = sfendacc(sds_id)
  	
  	
  	!------Create the SDS Relative Azimuth---------------------------------------------
	rank =1
	start(1)=0
	edges(1)=numOfAzmAngs
	stride(1)=1
	dimArray(1) = numOfAzmAngs
	
    SDSName = 'ReflectanceRelativeAzimuth'!'ReflCosineOfViewAng'
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), relazm)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfAzimuthAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'Degrees')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
   longName = 'Reflectance: Relative Azimuth in Degrees'
  	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

    deltamu =5.0
    retstat = sfsnatt(sds_id, 'increment=deltatheta', DFNT_FLOAT, 1, deltamu)

    
  	retstat = sfendacc(sds_id)

  	
  	
  !------Create the SDS of Extinction Coefficients-------------------------------
	rank =2
	start(:)=0
	stride(:)=1
	dimArray(1) = numOfWavelengths
	dimArray(2) = numOfIceRe
	edges(1)=numOfWavelengths
	edges(2)=numOfIceRe
	
	
    SDSName = 'ExtinctionCoefficient'
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank,dimArray)
    
    retstat = sfwdata(sds_id, start(1:2), stride(1:2), edges(1:2), extCoeffs)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfWaveLengths'
  	retstat = sfsdmname(dim_id, trim(dimensionName))
     dim_id = sfdimid(sds_id,1)
   	dimensionName = TRIM(SDSName)//':  NumOfEffecRadii'
   	retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
   longName =  'Volume Extinction Coefficients'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

        
  	retstat = sfendacc(sds_id)
  	
  	
  	

 !------Create the SDS Single Scattering Albedo-------------------------------
	rank =2
	start(:)=0
	stride(:)=1
	dimArray(1) = numOfWavelengths
	dimArray(2) = numOfIceRe
	edges(1)=numOfWavelengths
	edges(2)=numOfIceRe
	
    SDSName = 'SingleScatterAlbedo'
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1:2), stride(1:2), edges(1:2), ssAlbedo)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
      dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//':  NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName =  'Singel Scattering Albedo'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))
    
  	retstat = sfendacc(sds_id)

  	
  	
  	!------Create the SDS for Asymmemtry Parameter--------------------------------------
	rank =2
	start(:)=0
	stride(:)=1
	dimArray(1) = numOfWavelengths
	dimArray(2) = numOfIceRe
	edges(1)=numOfWavelengths
	edges(2)=numOfIceRe
	
	
    SDSName = 'Phase: AsymmetryParameter'
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1:2), edges(1:2), asymParameter)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':   NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
      dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//': NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName = 'Asymmetry Parameter from Phase Functions'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

        
  	retstat = sfendacc(sds_id)
  	
  	!-----------------------------------------------------------------------------------  	
  	!------Create the SDS Delta f, phase func trunc factor------------------------------
	rank =2
	start(:)=0
	stride(:)=1
	dimArray(1) = numOfWavelengths
	dimArray(2) = numOfIceRe
	edges(1)=numOfWavelengths
	edges(2)=numOfIceRe
	
	
    SDSName = 'TruncationFactor'
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1:2), edges(1:2), truncFac)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':   NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
      dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//': NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName = 'Phase Function truncation Factor-DFIT'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

        
  	retstat = sfendacc(sds_id)
  	
  	!-----------------------------------------------------------------------------------  	
    !------Create the SDS phase func normalization factor ------------------------------
	rank =2
	start(:)=0
	stride(:)=1
	dimArray(1) = numOfWavelengths
	dimArray(2) = numOfIceRe
	edges(1)=numOfWavelengths
	edges(2)=numOfIceRe
	
	
    SDSName = 'PhaseFuncNormConstant'
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1:2), edges(1:2), pmom0Array)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':   NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
      dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//': NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName = 'Phase Function Normalization Factor for Single Scat Calculations'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

        
  	retstat = sfendacc(sds_id)
  	
  	!-----------------------------------------------------------------------------------  	
!------Create the SDS Wavelengths for Fluxes----------------------------------------
!	rank =1
!	start(1)=0
!	edges(1)=numOfWavelengthsRFTF
!	stride(1)=1
!	dimArray(1) = numOfWavelengthsRFTF
!	
!    SDSName = 'WaveLengthsFluxes'
!    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
!    
!    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), waveLengthsRFTF)
!    dim_id = sfdimid(sds_id,0)
!    dimensionName = TRIM(SDSName)//':  NumOfWaveLengths'
!    retstat = sfsdmname(dim_id, trim(dimensionName))
!   
!    !Units
!    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'microns')
!    !scale_factor
!    scaleFactor = 1.d0
!    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
!     longName = 'Wavelengths for which the fluxes are computed'
! 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))
!   
!       
!    retstat = sfendacc(sds_id)
!
!-----------------------------------------------------------------------------------

  	!------Create the SDS Cosine of Solar Zenith for Fluxes----------------------------------------
	rank =1
	start(1)=0
	edges(1)=numOfSolarAngsRFTF
	stride(1)=1
	dimArray(1) = numOfSolarAngsRFTF
	
   ! SDSName = 'ReflectanceMU0' !'ReflCosineOfSolarAng'
    SDSName = 'FluxSolarZenith' !'ReflCosineOfSolarAng'
    
    sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
    
    retstat = sfwdata(sds_id, start(1), stride(1), edges(1), solarmuRFTF)
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//':  NumOfSolarAnglesRFTF'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    !Units
    retstat = sfscatt(sds_id, 'units', DFNT_CHAR8, 8, 'NONE')
       
    !scale_factor
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    
    !delta mu0
    !retstat = sfsnatt(sds_id, 'increment=deltamu0', DFNT_FLOAT, 1, deltamu0)
	longName ='Flux: Cosine of the Solar Angle'
 	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

    
    comment = 'deltamu0 = 0.05'
    retstat = sfsnatt(sds_id, 'Comment', DFNT_CHAR, len(TRIM(comment)), trim(comment))

    
  	retstat = sfendacc(sds_id)

  	!------Create the SDS, Plane Albedo (Reflected Flux)--------------------------------	
	rank  = 4
	start(:)=0
	stride(:)=1
	DIM3 = numOfIceRe
	DIM1 = numOfTau
	DIM0 = numOfSolarAngsRFTF
	DIM2 = numOfWavelengthsRFTF
	dimArray(1:rank) = (/DIM0,DIM1,DIM2,DIM3/)
	
	edges(1:rank)=dimArray(1:rank)
	

	SDSName = 'ReflectedFlux'
	sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
	retstat = sfwdata(sds_id, start(1:rank), stride(1:rank), edges(1:rank), planeAlbedo)
	

	 dim_id = sfdimid(sds_id,2)
    dimensionName = TRIM(SDSName)//': NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//': NumOfSolarAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
	
	
	dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//': NumOfOpticalThickness'
    retstat = sfsdmname(dim_id, trim(dimensionName))
	
	
	dim_id = sfdimid(sds_id,3)
    dimensionName = TRIM(SDSName)//': NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName =  'Reflected Flux (Plane Albedo)'
  	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))

    
	retstat = sfendacc(sds_id)

  	!-----------------------------------------------------------------------------------
  	!-----------------Create the SDS, Transmittivity (Transmitted Flux)-----------------	
	rank  = 4
	start(:)=0
	stride(:)=1
	DIM3 = numOfIceRe
	DIM1= numOfTau
	DIM0 = numOfSolarAngsRFTF
	DIM2 = numOfWavelengthsRFTF
	dimArray(1:rank) = (/DIM0,DIM1,DIM2,DIM3/)
	
	edges(1:rank)=dimArray(1:rank)
	

	SDSName = 'TransmittedFlux'
	sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
	retstat = sfwdata(sds_id, start(1:rank), stride(1:rank), edges(1:rank), transmittivity)
	

	 dim_id = sfdimid(sds_id,2)
    dimensionName = TRIM(SDSName)//': NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//': NumOfSolarAngles'
    retstat = sfsdmname(dim_id, trim(dimensionName))
	
	
	dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//': NumOfOpticalThickness'
    retstat = sfsdmname(dim_id, trim(dimensionName))
	
	
	dim_id = sfdimid(sds_id,3)
    dimensionName = TRIM(SDSName)//': NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
    longName = 'Transmitted Flux (Transmittivity)'
    retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))
 
	retstat = sfendacc(sds_id)
	!-----------------------------------------------------------------------------------
  	!--------------Create the SDS, Spherical Albedo-------------------------------------	
	rank  = 3
	start(:)=0
	stride(:)=1
	DIM2 = numOfIceRe
	DIM0 = numOfTau
	DIM1 = numOfWavelengthsRFTF
	dimArray(1:rank) = (/DIM0,DIM1,DIM2/)
	
	edges(1:rank)=dimArray(1:rank)
	

	SDSName = 'SphericalAlbedo'
	sds_id = SFcreate(hdf_id, trim(SDSName), DFNT_FLOAT, rank, dimArray(1:rank))
	retstat = sfwdata(sds_id, start(1:rank), stride(1:rank), edges(1:rank), sphericalAlbedo)
	

	 dim_id = sfdimid(sds_id,1)
    dimensionName = TRIM(SDSName)//': NumOfWaveLengths'
    retstat = sfsdmname(dim_id, trim(dimensionName))
  	
	dim_id = sfdimid(sds_id,0)
    dimensionName = TRIM(SDSName)//': NumOfOpticalThickness'
    retstat = sfsdmname(dim_id, trim(dimensionName))
	
	
	dim_id = sfdimid(sds_id,2)
    dimensionName = TRIM(SDSName)//': NumOfEffecRadii'
    retstat = sfsdmname(dim_id, trim(dimensionName))
    
    scaleFactor = 1.d0
    retstat = sfsnatt(sds_id, 'Scale_Factor', DFNT_DOUBLE, 1, scaleFactor)
     longName =  'Spherical Albedo'
  	retstat = sfscatt(sds_id, 'long_name', DFNT_CHAR8, len(trim(longName)),trim(longName))
  
    
	retstat = sfendacc(sds_id)
   	
  	
	!------------------------Close the HDF File-----------------------------------------
  	retstat = sfend(hdf_id)
  	
    DEALLOCATE(pmom0Array,truncFac,asymParameter,ssAlbedo,effecRadii,extCoeffs, transmittivity,planeAlbedo, &
               sphericalAlbedo, multiScatRefl,iReICe)


	STOP
    !-----------------------------------------------------------------------------------  
    CONTAINS
      
    	!---------------------------getdateAndTime------------------------------------------
		!subroutine to get the current date and time as strings.
		!eg: date = SEP 9 1993, TIME = 12:59:46
		!INPUTS:
		!	NONE
		!OUTPUTS:
		!	date : string giving the current date
		!	time : string giving the time
		!ROUTINES CALLED:
		!fortran intrinsic routine date_and_time
		!-----------------------------------------------------------------------------------

		SUBROUTINE getdateAndTime(whatdate, whattime,dateTimeString)
		IMPLICIT NONE

		CHARACTER(11)::whatdate
		CHARACTER(8):: whattime
		CHARACTER(13)::dateTimeString

		CHARACTER(8)::date1
		CHARACTER(10)::time1
		CHARACTER(5)::zone
		CHARACTER(3)::dayoftheyear
		INTEGER::values(8),result,values1(9)
		INTEGER::Time

		CALL date_and_time(date1,time1,zone, values)
			     result = TIME()
	     
	     CALL GMTIME(result,values1)
	     

		 write( dayoftheyear,'(i3.3)')values1(8)+1
		 dateTimeString = date1(1:4)//dayoftheyear//time1(1:2)//time1(3:4)//time1(5:6)

		SELECT CASE(values(2))
			CASE(1)
				whatdate(1:3) = 'JAN'
			CASE(2)
				whatdate(1:3) = 'FEB'
			CASE(3)
				whatdate(1:3) = 'MAR'
			CASE(4)
				whatdate(1:3) = 'APR'
			CASE(5)
				whatdate(1:3) = 'MAY'
			CASE(6)
				whatdate(1:3) = 'JUN'
			CASE(7)
				whatdate(1:3) = 'JUL'
			CASE(8)
				whatdate(1:3) = 'AUG'
			CASE(9)
				whatdate(1:3) = 'SEP'
			CASE(10)
				whatdate(1:3) = 'OCT'
			CASE(11)
				whatdate(1:3) = 'NOV'
			CASE(12)
				whatdate(1:3) = 'DEC'
		END SELECT

		whatdate(4:11) = ' ' // date1(7:8) // ' ' // date1(1:4)
		whattime = time1(1:2)//':'//time1(3:4)//':'//time1(5:6)
		RETURN
		END SUBROUTINE getDateAndTime
      
      
    END PROGRAM createIceRefLibraryHDF_EMAS_DP_WithReUNC