pro calcTotalLandLutRefl
;  T=SYSTIME(1)
  
  
  
   


;;;; LUT Information;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  LUTDIR = '/Users/nandana/MODIS_ACOL_LUTS/'; path to where the library folder MODIS_C6_LUTS is located;
  
  phaseFileName       = LUTDIR + 'MODIS_C6_LUTS/modis_water/IceAndWaterPhaseFunctionData_2013.hdf'

  lambWaterLUTName    = LUTDIR + 'MODIS_C6_LUTS/modis_water/reflectance_water_library.hdf'
  
  lambIceLUTName      = LUTDIR + 'MODIS_C6_LUTS/modis_ice/reflectance_ice_library.hdf'
  
;;;;;;;;END LUT Information;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  

 

 nphi = 37
 numu = 28
 nsolar = 33
 
 
 
 deltaphi=5.0
 relazm = findgen(nphi) * deltaphi
  
  zviewmu = fltarr(numu)
  solarmu = fltarr(nsolar)
   zviewmu[0:7] = (findgen(8)*0.05 + 0.40)
  zviewmu[8:27] = (findgen(20)*0.0125 + 0.75+0.0125)
  solarmu[0:12]= findgen(13)*0.05 + 0.15
  solarmu[13:32]= findgen(20)*0.0125 + 0.75 + 0.0125
   
 solarangvec = acos(solarmu) * 180.D0/!PI
 viewangvec = fltarr(numu)
 viewangvec = acos(zviewmu) * 180.D0/!PI
 

print,'Given below are the 37 azimuth, 33 solar, and 28 view angles for LUTs'
print,'Pick/choose the angular geometry from these angles'
print
print, 'index','azimuth', 'solar','view',format='(1x,a,3x,a,6x,a,6x,a)

for i = 0, nphi-1 do begin
if(i lt 28)then print, i+1, relazm[i], solarangvec[i], viewangvec[i], format='(i4, 6x, f4.0, 8x, f5.2, 6x, f5.2)'
if(i ge 28 and i lt 33)then print, i+1, relazm[i], solarangvec[i],format='(i4, 6x, f4.0, 8x, f5.2)'
if(i ge 33)then print,i+1, relazm[i],format='(i4, 6x, f4.0)
end

iazm=0L
isol=0L
iumu=0L
print
print,'Pick the indices of the angle combination to run.'
print,'(Example output was created with all angles = 60, i.e., iazm=13, isol=8, iview=3 & surfalb=0.0)'
read,iazm,prompt='Enter index for the rel azimuth: '
azmang=relazm[iazm-1]  ;;to get the idl indexing
print,'Relative Azimuth = ',azmang,' degrees',format='(a,f6.2,a)'
read,isol,prompt='Enter index for the solar zenith: '
solang = acos(solarmu[isol-1]) * 180.D0/!PI
print,'Solar Zenith = ',solang,' degrees',format='(a,f5.2,a)'

read,iumu,prompt='Enter index for the zensor zenith: '
viewang = acos(zviewmu[iumu-1]) * 180.D0/!PI
print,'Sensor Zenith/View = ',viewang,' degrees',format='(a,f5.2,a)'

read,surfalb,prompt='Now enter a value for the surface albedo: '
iag = floor(surfalb)
fag = 100*(surfalb - iag)
tstamp=timestamp()

outFile = string(LUTDIR, 'MODIS_C6_LUTS/OUTPUT/land_IDL_C6_reflectance_sol_',isol,'_view_',iumu,'_relazm_',iazm,$
          '_ag_',iag,'pt',fag,'_',tstamp,'.hdf',format='(a,a,i02,a,i02,a,i02,a,i1,a,i02,a,a,a)') 
print,outFile


 



;;;;;;; Compute and compare Lambertian Reflectances : Water & Ice;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  getPhaseFunctionData,phaseFileName,pfstruct    ; called once to get phase function data
  ;get water refl
  readLandOrOceanLUTData, lambWaterLUTName,solang,viewang,azmang,lutdat,sscdat,/land
  lambWater=getReflForGivenSurfAlbedo_flip(pfstruct,lutdat,sscdat,solang,viewang,azmang,surfalb,'LIQUID')
  lambWater = reform(lambWater)
  rew = sscdat.RE
  tau = sscdat.COT
  lambda = sscdat.WVL
  ;;;get ice refl
  readLandOrOceanLUTData, lambIceLUTName,solang,viewang,azmang,lutdat,sscdat,/land
  lambIce=getReflForGivenSurfAlbedo_flip(pfstruct,lutdat,sscdat,solang,viewang,azmang,surfalb,'ICE')
  lambIce = reform(lambIce)
  rei = sscdat.RE
  angs=[solang, viewang, azmang]
  createHDFFile,outFile,lambWater,lambIce,angs,surfalb,rew,rei,tau,lambda,/land
  
  lutdat = 0
  sscdat = 0
;    PRINT, SYSTIME(1) - T, 'Seconds'
  
;  
  
end
