; NAME :    
;           getPhaseFunctionData
; PURPOSE :
;           Read HDF file with phase function data into a IDL structure
;    
; CALLING :
;           getPhaseFunctionData, phasename,pfstruct
;                        
; INPUTS  :
;           phasename    = Name of the HDF file with phase function data
; OUTPUT  :
;           pfstruct = structure containing liquid and ice phase function data            
; HISTORY:
; Written: Nandana Amarasinghe, SSAI @ NASA/GSFC, 2017.
;



pro getPhaseFunctionData, phasename,struct

  
  ;help,struct
  variables=['WaterPhaseFuncVals','ScatAnglesWater','IcePhaseFuncVals','ScatAnglesIce']
  tagnames=['liqPF','liqSA','icePF','iceSA']
  sd_id = HDF_SD_START(phasename, /READ)
;  data      = getDatafromHDFFile(sd_id,variables[0])
  ;struct=create_struct(tagnames[0],data)
  struct={}
  for i = 0,n_elements(variables)-1 do begin
    data      = getDatafromHDFFile(sd_id,variables[i])
    struct=create_struct(temporary(struct),tagnames[i],temporary(data)) 
  end
  HDF_SD_END, sd_id


end