
; NAME :    
;           getDatafromHDFFile
; PURPOSE :
;           Given the sd_id and the name of the variable, read the data
;    
; CALLING :
;           array = getDatafromHDFFile(sd_id, variable)
;                        
; INPUTS  :
;           sd_id    = sds id
;           variable   = variable name
; OUTPUT  :
;           Array = data corresponds to tha variable in the HDF file
;              
; HISTORY:
; Written: Nandana Amarasinghe, SSAI @ NASA/GSFC, 2017.
;



FUNCTION getDatafromHDFFile,sd_id, variable, CTVEC = vecct, STARTVEC = vecst


  sds_id = hdf_sd_select(sd_id,hdf_sd_nametoindex(sd_id,variable))
  if keyword_set(vecct) then begin
    hdf_sd_getdata,sds_id,data,COUNT=vecct,START=vecst
  endif else begin
      hdf_sd_getdata,sds_id,data
  endelse
  
  hdf_sd_endaccess,sds_id
  
  RETURN, data
 END