; NAME :    
;           interpolateFluxes_flip
; PURPOSE :
;           Linearly interpolate Fluxes for a given sun-satellite geometry
;    
; CALLING :
;           interpolateFluxes_flip, solorview,sol,inFlux, outFlux
;           solorview can be a scalar or vectors of the same length
;                        
; INPUTS  :
;           imi     = index to whitch the interpolation is desired
;           inFlux     = Flux (relevant to lower & upper indices of geometry)
; OUTPUT  :
;           outFlux = Array containing flux
;              
; HISTORY:
; Written: Nandana Amarasinghe, SSAI @ NASA/GSFC, 2017.
;

pro interpolateFluxes_flip, imi, inFlux, outFlux

  
  inFlux = (inFlux gt 10E-9)*inFlux
   outFlux=(interpolate(inFlux,imi))
   outFlux = (outFlux gt 10E-9)*outFlux
end